// Save configuration into registry class unit
// Copyright (c)  , 2005

unit Config;

interface

uses Classes, SysUtils, Forms, TypInfo, Registry;

type
  TConfiguration = class(TComponent)
  private
    FRoot: Cardinal;
    FKey: string;
  public
    constructor Create(AOwner: TComponent;
      ARoot: Cardinal; AKey: string); reintroduce;
    destructor Destroy; override;
    procedure Save; virtual;
    procedure Load; virtual;
    property Root: Cardinal read FRoot;
    property Key: string read FKey;
  published

  end;


implementation

{ TConfiguration }

constructor TConfiguration.Create(AOwner: TComponent;
  ARoot: Cardinal; AKey: string);
begin
  inherited Create(AOwner);
  FRoot := ARoot;
  FKey := AKey;
  Name := 'TestUnit';
end;

destructor TConfiguration.Destroy;
begin
  inherited;
end;

procedure TConfiguration.Load;
var
  PropList: PPropList;
  PropCount, i: Integer;
  reg: TRegistry;
  val: String;
begin
  //    
  PropCount := GetTypeData(ClassInfo).PropCount;

  //  
  GetMem(PropList, sizeof (PPropInfo) * PropCount);

  //   
  reg := TRegistry.Create;
  try
    //   
    reg.RootKey := Root;

    //  -  
    PropCount := GetPropList (ClassInfo,
      [tkInteger, tkChar, tkFloat, tkLString, tkInt64],PropList);

    //   
    for i:=0 to PropCount - 1 do
    begin
      //   
      if (PropList[i].PropType^^.Kind = tkInteger)
        or (PropList[i].PropType^^.Kind = tkInt64)
        or (PropList[i].PropType^^.Kind = tkFloat) then
      begin
        //  () 
        reg.OpenKey(Key, True);
        //    
        val := reg.ReadString(PropList[i].Name);
        // ,     
        if val <> '' then
          SetPropValue(Self,PropList[i].Name, StrToFloatDef(val,0));
        //  
        reg.CloseKey;
        Continue;
      end;
      //   
      if (PropList[i].PropType^^.Kind = tkLString)
        or (PropList[i].PropType^^.Kind = tkChar) then
      begin
        reg.OpenKey(Key, True);
        val := reg.ReadString(PropList[i].Name);
        SetPropValue(Self,PropList[i].Name, val);
        reg.CloseKey;
        Continue;
      end;

      {-------    -------}

    end;
  finally
    //  
    FreeMem(PropList);
    reg.Free;
  end;
end;


procedure TConfiguration.Save;
var
  PropList: PPropList;
  PropCount, i: Integer;
  reg: TRegistry;
begin
  PropCount := GetTypeData(ClassInfo).PropCount;
  GetMem(PropList, sizeof (PPropInfo) * PropCount);
  reg := TRegistry.Create;
  try
    reg.RootKey := Root;
    PropCount := GetPropList (ClassInfo, [tkInteger,
      tkChar, tkFloat, tkLString, tkInt64],PropList);
    for i:=0 to PropCount - 1 do
    begin
      if (PropList[i].PropType^^.Kind = tkInteger)
        or (PropList[i].PropType^^.Kind = tkInt64)
        or (PropList[i].PropType^^.Kind = tkFloat) then
      begin
        reg.OpenKey(Key, True);
        reg.WriteString(PropList[i].Name,
          FloatToStr(GetPropValue(Self,PropList[i].Name)));
        reg.CloseKey;
        Continue;
      end;
      if (PropList[i].PropType^^.Kind = tkLString)
        or (PropList[i].PropType^^.Kind = tkChar) then
      begin
        reg.OpenKey(Key, True);
        reg.WriteString(PropList[i].Name,
          GetPropValue(Self,PropList[i].Name));
        reg.CloseKey;
        Continue;
      end;
      {-------    -------}
    end;
  finally
    FreeMem(PropList);
    reg.Free;
  end;
end;


end.
